SystemOrganization addCategory: #'GT-SpotterExtensions-Core'!

!SettingNode methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 3/13/2015 22:02'!
spotterForSettingsFor: aStep
	<spotterOrder: 0>
	self allChildren isEmpty ifTrue: [ ^ self ].
	aStep listProcessor
		title: 'Children';
		allCandidates: [ self allChildren ];
		itemName: [ :each | each spotterLabel ];
		filter: GTFilterSubstring! !

!SettingNode methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 3/12/2015 16:57'!
spotterLabel
	| label |
	label := self settingDeclaration label.
	^ self parentNode isNil
		ifTrue: [ label ]
		ifFalse: [ self parentNode spotterLabel , '/', label ]
		! !

!SettingNode methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 3/20/2015 10:06'!
spotterPreviewIn: composite
	<spotterPreview: 0>
	
	composite custom: (
				(self settingDeclaration inputWidget asBrick)
						hSpaceFill;
						vShrinkWrap;
						vAlign: #center;
						yourself)! !

!TClassDescription methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/26/2015 21:01'!
spotterPackageFor: aStep
	<spotterOrder: 50>
	aStep listProcessor
			title: 'Package';
			allCandidates: [ {self package} ];
			itemName: [ :item | item packageName ];
			itemIcon: #systemIcon;
			filter: GTFilterSubstring! !

!TestCase class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 18:52'!
spotterForSuiteFor: aStep
	<demoyOnly: 'NautilusUI - this is an ugly implementaiton - just to demo it'>
	<spotterOrder: 1>
	aStep listProcessor
		title: 'Tests';
		allCandidates: [ Array with: self suite ];
		itemName: [ :item | item name ];
		itemIcon: #systemIcon;
		actLogic: [ :item | NautilusUI new runTestsOfSuite: item notifying: true ];
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!TestCase class methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:44'!
spotterForSuitesFor: aStep
	<demoOnly: 'NautilusUI - this is an ugly implementaiton - just to demo it '>
	<spotterOrder: 1>
	aStep listProcessor
		title: 'Testcases';
		allCandidates: [ 
			self testSelectors collect: [ :each | 
				(self buildSuiteFromMethods: { each }) name: each; yourself ] ];
		itemName: [ :item | item name ];
		itemIcon: #systemIcon;
		actLogic: [ :item | NautilusUI new runTestsOfSuite: item notifying: true ];
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!ThemeIcons methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 3/6/2015 13:07'!
spotterForIconsFor: aStep
	<spotterOrder: 10>
	aStep listProcessor
		title: 'Icons';
		allCandidates: [ 
			self iconSelectors asSortedCollection 
				collect: [ :each | each -> (self perform: each) ] ];
		itemIcon: #value;
		itemName: #key;
		actLogic: [ :association | (self class lookupSelector: association key) browse ];
		filter: GTFilterSubstring! !

!MCVersionInfo methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 2/27/2015 09:59'!
allAncestors
	^ (self allAncestorsTo: OrderedCollection new)
		sort: [ :a :b | a timeStamp >= b timeStamp ]! !

!MCVersionInfo methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 2/27/2015 10:02'!
allAncestorsTo: aCollection
	self ancestors do: [ :versionInfo | 
		" do not add/process ancestry-branches which have already been added/processed "
		(aCollection includes: versionInfo) ifFalse: [ 
			aCollection add: versionInfo.
			versionInfo allAncestorsTo: aCollection ] ].
	^ aCollection! !

!MCVersionInfo methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/17/2015 16:54'!
gtDisplayOn: stream
	stream nextPutAll: self name! !

!MCVersionInfo methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/26/2015 23:21'!
spotterAncestorsFor: aStep
	<spotterOrder: 1>
	aStep listProcessor
		title: 'Ancestors';
		allCandidates: [ self allAncestors ];
		filter: GTFilterSubstring! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 2/27/2015 11:46'!
concreteMethodsInContext: aContext
	" return the concrete methods described by the expression (Class >> #Selector) - evaluate it savely "
	| methods classAndSelectorStrings class selector |
	methods := OrderedCollection new.
	classAndSelectorStrings := (aContext textTrimmed splitOn: '>>') collect: [ :each | each trimBoth ].
	" check preconditions "
	classAndSelectorStrings size = 2 ifFalse: [ ^ methods ].
	classAndSelectorStrings second size < 2 ifTrue: [ ^ methods ].
	classAndSelectorStrings second first = $# ifFalse: [ ^ methods ].
	" retrieve concrete class and selector "
	(class := Smalltalk classNamed: classAndSelectorStrings first) ifNil: [ ^ methods ].
	selector := classAndSelectorStrings second allButFirst asSymbol.
	" retrieve the compiled method in the class and class hierarchy "
	class withAllSuperclassesDo: [ :aClass |
		([ aClass compiledMethodAt: selector ] on: Error do: [ nil ]) 
			ifNotNilDo: [ :compiledMethod | 
				aContext addItem: compiledMethod.
				methods add: compiledMethod ] ].
	^ methods! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 3/22/2015 21:42'!
evaluateExpressionInContext: aSpotterContext usingFilter: filter
	" only allow arithmethic selectors to be evaluated - otherwise this may have some severe side-effects "
	| result |
	" filter allowed selectors "
	(Number withAllSubclasses anySatisfy: [ :class |
		class selectors anySatisfy: [ :selector | 
			aSpotterContext textTrimmed includesSubstring: selector caseSensitive: true ] ]) ifFalse: [ ^ self ].
	" perform the selector "
	result := [ Compiler evaluate: aSpotterContext textTrimmed ] 
		on: Error 
		do: [ ^ self ].
	result isNumber ifFalse: [ ^ self ].
	filter value: result. 
	" if the result is not readable as float, append the float as well "
	(result isFraction and: [ result isInteger not ]) ifTrue: [
		filter value: result asFloat ]! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 3/22/2015 23:30'!
fileReferencesBy: aSelector inContext: aSpotterContext usingFilter: aBlock
	| split rootDirectory query |
	split := aSpotterContext textLowercase piecesCutWhere: [ :a :b | a = FileSystem disk delimiter ].
	split size < 1
		ifTrue: [ 
			query := aSpotterContext textLowercase.
			rootDirectory := FileSystem workingDirectory ]
		ifFalse: [ 
			(split last last = FileSystem disk delimiter)
				ifTrue: [ 
					query := ''.
					rootDirectory := aSpotterContext textLowercase asFileReference ]
				ifFalse: [ 
					query := split last.
					rootDirectory := ('' join: split allButLast) asFileReference ] ].
	rootDirectory exists ifFalse: [ ^ self ].
	" hack: see senders of #queryForFileReference "
	aSpotterContext cacheAt: #queryForFileReference put: query.
	(rootDirectory perform: aSelector) do: aBlock! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/27/2015 11:26'!
spotterConcreteMethodFor: aStep
    <spotterOrder: 30>
	^ aStep listProcessor
		title: 'Method';
		filter: [ :context | self concreteMethodsInContext: context ];
		wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:45'!
spotterDirtyMonticelloPackagesFor: aStep
	<spotterOrder: 85>
	aStep listProcessor
			allCandidates: [ MCWorkingCopy allManagers select: #modified ];
			title: 'Dirty Monticello packages';
			itemIcon: [ Smalltalk ui icons iconNamed: #dirtyPackageIcon ];
			filter: GTFilterSubstring;
			wantsToDisplayOnEmptyQuery: true! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:45'!
spotterForClassesFor: aStep
	<spotterOrder: 10>
	aStep listProcessor
			allCandidates: [ Smalltalk allClassesAndTraits ];
			title: 'Classes';
			filter: GTFilterSubstring;
			itemIcon: #systemIcon;
			wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/22/2015 21:44'!
spotterForDirectoriesFor: aStep
	<spotterOrder: 50>
	self flag: #specialFilter.
	aStep listProcessor
		title: 'Directories';
		itemIcon: [ GLMUIThemeExtraIcons glamorousFolder ];
		itemFilterName: [ :reference | reference basename ];
		filter: GTFilterFileReference item: [ :filter :context | 
			self fileReferencesBy: #directories inContext: context usingFilter: filter ];
		wantsToDisplayOnEmptyQuery: false	! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/22/2015 21:42'!
spotterForExpressionsFor: aStep
	<spotterOrder: 1>
	self flag: #specialFilter.
	aStep listProcessor
		title: 'Calculator';
		filter: GTNullFilter item: [ :filter :context | 
			self evaluateExpressionInContext: context usingFilter: filter ];
		wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/22/2015 21:45'!
spotterForFilesFor: aStep
	<spotterOrder: 40>
	self flag: #specialFilter.
	aStep listProcessor
		title: 'Files';
		itemIcon: [ GLMUIThemeExtraIcons glamorousBrowse ];
		itemFilterName: [ :reference | reference basename ];
		filter: GTFilterFileReference item: [ :filter :context | 
			self fileReferencesBy: #files inContext: context usingFilter: filter ];
		wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:45'!
spotterForGlobalVarsFor: aStep
	<spotterOrder: 40>
	aStep listProcessor
			allCandidates: [ Smalltalk globals associations select:[:assoc | 
			assoc value isBehavior not and:[ 
				assoc value isTrait not]] ];
			title: 'Global variables';
			itemName:[:global | global key ];
			filter: GTFilterSubstring;
			wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 3/6/2015 14:40'!
spotterForHelpTopicFor: aStep
	<spotterOrder: 200>
	aStep listProcessor 
			allCandidates: [ SystemHelp asHelpTopic gtAllSubtopics ];
			title: 'Help topics';
			itemName: [ :helpTopic | helpTopic title ];
			itemIcon: [ :helpTopic | helpTopic gtTopicIcon ];
			matchSubstrings;
			wantsToDisplayOnEmptyQuery: true! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/27/2015 09:07'!
spotterForMetacelloConfigurationsFor: aStep
	<spotterOrder: 86>
	aStep listProcessor
			title: 'Metacello Configurations';
			allCandidates: [ 
				Smalltalk allClasses select: [ :each | 
					(each respondsTo: #isMetacelloConfig) 
						and: [ each isMetacelloConfig
							and: [ each name beginsWith: 'ConfigurationOf' ] ] ]
					thenCollect: #project ];
			itemName: [ :each | each configuration class name ];
			itemIcon: [ Smalltalk ui icons iconNamed: #configIcon ];
			filter: GTFilterSubstring;
			wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:45'!
spotterForPackagesFor: aStep
	<spotterOrder: 20>
	aStep listProcessor
			allCandidates: [ RPackageOrganizer default packages ];
			title: 'Packages';
			itemName: [ :package | package name ];
			itemIcon: [ Smalltalk ui icons iconNamed: #packageIcon ];
			filter: GTFilterSubstring;
			wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/22/2015 21:32'!
spotterForPlaygroundPagesFor: aStep
	<spotterOrder: 100>
	aStep listProcessor
			allCandidates: [ GTPlayBook instance pagesSorted ];
			title: 'Playground';
			itemName: [ :page | page content asString contractTo: 100 ];
			filter: GTFilterSubstring! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/8/2015 14:13'!
spotterForPragmasFor: aStep
	<spotterOrder: 40>
	aStep listProcessor 
			allCandidates: [ PragmaType all ];
			title: 'Pragmas';
			itemName: [ :pragma | pragma keyword ];
			filter: GTFilterSubstring;
			wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/27/2015 09:08'!
spotterForRepositoriesFor: aStep
	<spotterOrder: 87>
	aStep listProcessor
		title: 'Monticello Repositories';
		allCandidates: [ MCRepositoryGroup default repositories ];
		itemIcon: #systemIcon;
		wantsToDisplayOnEmptyQuery: false;
		filter: GTFilterSubstring! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 3/20/2015 10:46'!
spotterForSettingsFor: aStep
	<spotterOrder: 100>
	aStep listProcessor
		title: 'Settings';
		allCandidates: [ (SettingTree new acceptableKeywords: SettingBrowser settingsKeywords) nodeList ];
		itemName: [ :each | each spotterLabel ];
		filter: GTFilterSubstring! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:45'!
spotterForTestClassesFor: aStep
	<demoOnly: 'NautilusUI - this is a very ugly implementaiton - just for demo'>
	<spotterOrder: 20>
	aStep listProcessor
		title: 'Tests';
		allCandidates: [ TestCase allSubclasses ];
		itemName: [ :item | item name ];
		itemIcon: #systemIcon;
		actLogic: [ :item | NautilusUI new runTestsOfClass: item notifying: true ];
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: false! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/8/2015 14:11'!
spotterHistoryFor: aStep
	<spotterOrder: 8>
	aStep listProcessor
			allCandidates: [ self class history asArray select: [ :each | each isNotNil and: [ each value isNotNil ] ] ];
			title: 'History';
			itemName: [ :item | 
				item class = GTSpotterProcessorLink 
					ifTrue: [ item processor itemNameFor: item value ] " HACK: this triggers a recursion !! ... but processor is undefined for aCandidate "
					ifFalse: [ item gtDisplayString ] ];
			filter: GTFilterSubstring! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/22/2015 21:39'!
spotterImplementorsFor: aStep
	<spotterOrder: 30>
	self flag: #specialFilter.
	aStep listProcessor
		title: 'Implementors';
		itemFilterName: [ :method | method selector asString ];	
		filter: GTFilterSubstring item: [ :filter :context | 
			SystemNavigation default allBehaviorsDo: [ :class | class methodsDo: filter ] ]! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/22/2015 21:39'!
spotterStfxFor: aStep
	<spotterOrder: 30>
	self flag: #specialFilter.
	^ aStep listProcessor
		title: 'ws.stfx.eu';
		filter: GTNullFilter item: [ :filter :context | 
			(context textTrimmed beginsWith: 'http://ws.stfx.eu')
				ifTrue: [ GTPlayPage loadFromPublishUrl: context textTrimmed thenDo: filter ] ]! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/17/2014 12:56'!
spotterWorldMenuFor: aStep
	<spotterOrder: 9>
	^ (World worldMenu spotterItemsFor: aStep)
		title: 'Menu'! !

!RPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/11/2014 21:21'!
spotterActDefault
	^ PackageTreeNautilus openOnPackage: self! !

!RPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:46'!
spotterClassesFor: aStep
	<spotterOrder: 20>
	aStep listProcessor
			allCandidates: [ self definedClasses sorted: [ :a :b | a name < b name ] ];
			title: 'Classes';
			filter: GTFilterSubstring! !

!RPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:46'!
spotterExtensionMethodsFor: aStep
	<spotterOrder: 30>
	aStep listProcessor
			allCandidates: [ self extensionMethods ];
			title: 'Extension Methods';
			filter: GTFilterSubstring! !

!RPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/12/2015 14:19'!
spotterMonticelloPackageFor: aStep
	<spotterOrder: 41>
	aStep listProcessor
		title: 'Monticello Package';
		allCandidates: [ self mcPackage 
			ifNotNilDo: [ :mcPackage | Array with: mcPackage ] 
			ifNil: [ #() ] ];
		itemIcon: [ Smalltalk ui icons iconNamed: #monticelloPackageIcon ];
		filter: GTFilterSubstring! !

!RPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/12/2015 14:19'!
spotterMonticelloWorkingCopyFor: aStep
	<spotterOrder: 42>
	aStep listProcessor
		title: 'Monticello Working Copy';
		allCandidates: [ self mcPackage 
			ifNotNilDo: [ :mcPackage | Array with: mcPackage workingCopy ] 
			ifNil: [ #() ] ];
		itemIcon: [ Smalltalk ui icons iconNamed: #versionControlIcon ];
		filter: GTFilterSubstring! !

!RPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/28/2015 21:01'!
spotterPreviewCodeIn: aComposite
	<spotterPreview: 10>
	aComposite list
		title: 'Preview';
		display: [ :x | x ];
		format: [ :class | GTSpotterItemBrick new text: class gtDisplayString; icon: class systemIcon; disable; yourself ];
		entity: self classes asArray.
		
	self flag: 'move "entity: self" somewhere else, maybe'! !

!RPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/26/2015 21:01'!
spotterTagsFor: aStep
	<spotterOrder: 20>
	self classTags size <= 1 ifTrue: [ ^ self ].
	aStep listProcessor
			allCandidates: [ self classTags sorted: [ :a :b | a name < b name ] ];
			title: 'Tags';
			itemName: [ :item | item name ];
			filter: GTFilterSubstring! !

!MCPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/17/2015 17:17'!
gtDisplayOn: aStream
	aStream nextPutAll: self name! !

!MCPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:45'!
spotterForPackageFor: aStep
	<spotterOrder: 2>
	aStep listProcessor
		title: 'Packages';
		allCandidates: [ Array with: self correspondingRPackage ];
		itemName: [ :package | package name ];
		itemIcon: [ Smalltalk ui icons iconNamed: #packageIcon ];
		filter: GTFilterSubstring! !

!MCPackage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:45'!
spotterMonticelloWorkingCopyFor: aStep
	<spotterOrder: 1>
	aStep listProcessor
		title: 'Monticello Working Copy';
		allCandidates: [ Array with: self workingCopy ];
		itemIcon: [ Smalltalk ui icons iconNamed: #versionControlIcon ];
		filter: GTFilterSubstring! !

!Behavior methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:44'!
spotterClassInstanceVariablesFor: aStep
	<spotterOrder: 25>
	aStep listProcessor
			title: 'Class instance variables';
			allCandidates: [ self class layout allSlots ];
			itemName: [:each | each name asString];
			filter: GTFilterSubstring! !

!Behavior methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:44'!
spotterInstanceVariablesFor: aStep
	<spotterOrder: 20>
	aStep listProcessor
			title: 'Instance variables';
			allCandidates: [ self layout allSlots ];
			itemName: [:each | each name asString];
			filter: GTFilterSubstring! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 2/17/2015 19:22'!
allAncestors
	^ self versionInfo 
		ifNotNilDo: [ :versionInfo | versionInfo allAncestors ]
		ifNil: [ #() ]! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/17/2015 17:01'!
gtDisplayOn: stream
	ancestry ancestors isEmpty 
		ifTrue: [ 
			super gtDisplayOn: stream. stream nextPutAll: ' (unsaved)' ]
		ifFalse: [ 
			ancestry ancestors first gtDisplayOn: stream.
			self needsSaving ifTrue: [ stream nextPutAll: ' (modified)' ] ]
		! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 2/17/2015 18:09'!
nextAncestors
	^ self versionInfo 
		ifNotNilDo: [ :versionInfo | versionInfo ancestors ]
		ifNil: [ #() ]! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:45'!
spotterAllRepositoriesFor: aStep
	<spotterOrder: 20>
	aStep listProcessor
		title: 'All other repositories';
		allCandidates: [ MCRepositoryGroup default repositories \ self repositoryGroup repositories ];
		itemName: [ :item | item description ];
		actLogic: [ :item | self spotterCommit: self in: item ];
		filter: GTFilterSubstring! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/26/2015 23:21'!
spotterAncestorsFor: aStep
	<spotterOrder: 2>
	aStep listProcessor
		title: 'Ancestors';
		allCandidates: [ self allAncestors ];
		filter: GTFilterSubstring! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/3/2014 07:34'!
spotterCommit: workingCopy in: aRepository
	| newVersion |

	newVersion := workingCopy newVersionIn: aRepository.
	newVersion ifNil: [ ^ self ].
	Cursor wait showWhile: [
		[ 	aRepository storeVersion: newVersion.
			aRepository storeDependencies: newVersion ] 
		ensure: [ (MCVersionInspector new version: newVersion) show ]]! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:45'!
spotterMonticelloPackageFor: aStep
	<spotterOrder: 21>
	aStep listProcessor
		title: 'Monticello Package';
		allCandidates: [ Array with: self package ];
		itemIcon: [ Smalltalk ui icons iconNamed: #monticelloPackageIcon ];
		filter: GTFilterSubstring! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:45'!
spotterPackageFor: aStep
	<spotterOrder: 21>
	aStep listProcessor
		title: 'Packages';
		allCandidates: [ Array with: self package correspondingRPackage ];
		itemName: [ :item | item name ];
		itemIcon: [ Smalltalk ui icons iconNamed: #packageIcon ];
		filter: GTFilterSubstring! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:45'!
spotterPackageRepositoriesFor: aStep
	<spotterOrder: 10>
	aStep listProcessor
		title: 'Package repositories';
		allCandidates: [ self repositoryGroup repositories ];
		itemName: [ :item | item description ];
		actLogic: [ :item | self spotterCommit: self in: item ];
		filter: GTFilterSubstring! !

!MCWorkingCopy methodsFor: '*GT-SpotterExtensions-Core-private' stamp: 'StefanReichhart 2/17/2015 18:08'!
versionInfo
	^ self ancestors 
		ifNotEmptyDo: [ :list | list first ] 
		ifEmpty: [ nil ]! !

!HelpTopic methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 3/6/2015 14:11'!
gtAllSubtopics
	 ^ self subtopics flatCollect: [:aTopic |
		aTopic asOrderedCollection, aTopic gtAllSubtopics ]
		 ! !

!HelpTopic methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 3/6/2015 14:38'!
gtBreadcrumbTitle
	|breadcrumbTitle currentHelpTopic|
	
	currentHelpTopic := self.	
	breadcrumbTitle:= currentHelpTopic title.
	[ currentHelpTopic owner notNil and: [currentHelpTopic owner owner notNil ] ] whileTrue: [ 
		currentHelpTopic := currentHelpTopic owner.
		breadcrumbTitle := breadcrumbTitle , ' > ', currentHelpTopic title  ].
	^ breadcrumbTitle ! !

!HelpTopic methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 3/6/2015 14:31'!
gtTopicIcon
	^ (HelpIcons iconNamed: (self hasSubtopics
		 ifTrue: [#bookIcon] 
	    ifFalse: [#pageIcon]))! !

!HelpTopic methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/22/2015 21:40'!
spotterForHelpTopicFor: aStep
	<spotterOrder: 200>
	self flag: 'filter for multiple items like #title + #contents (combined by OR)'.
	self flag: #specialFilter.
	aStep listProcessor 
		title: 'Help contents';
		items: [ self subtopics ];
		itemName: [ :helpTopic | helpTopic title ];
		itemIcon: [ :helpTopic | helpTopic gtTopicIcon ];
		itemFilterName: [ :helpTopic | helpTopic contents asString ]; " the filter should only scan the contents / maybe title too ? "
		filter: GTFilterSubstrings;
		wantsToDisplayOnEmptyQuery: true! !

!HelpTopic methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 3/6/2015 12:58'!
spotterPreviewContentHelpIn: aComposite
	<spotterPreview: 10>
	
	self hasSubtopics ifTrue: [ ^ self ].
	aComposite text
		title: [ self title ];
		display: [:aHelpTopic | 
			aHelpTopic contents];
		entity: self.
		
	self flag: 'move "entity: self" somewhere else, maybe'! !

!HelpTopic methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 3/6/2015 14:31'!
spotterPreviewSubtopicsHelpIn: aComposite
	<spotterPreview: 15>

	aComposite list
		title: [ self title ];
		display: #yourself;
		format: [ :aHelpTopic | GTSpotterItemBrick new 
				text: aHelpTopic title;
				icon: aHelpTopic gtTopicIcon;
				disable ];
		styled: [ :brick | brick ];
		entity: self subtopics.
		
	self flag: 'move "entity: self" somewhere else, maybe'! !

!SettingTree methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 3/12/2015 16:56'!
spotterForSettingsFor: aStep
	<spotterOrder: 0>
	aStep listProcessor
		title: 'Settings';
		allCandidates: [ self nodeList ];
		itemName: [ :each | each spotterLabel ];
		filter: GTFilterSubstring! !

!MCHttpRepository methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/17/2015 15:50'!
gtDisplayOn: aStream
	aStream nextPutAll: self location! !

!TClass methodsFor: '*GT-SpotterExtensions-Core' stamp: 'NicolaiHess 2/5/2015 00:33'!
spotterActDefault
	^ self browse! !

!TClass methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AndreiChis 3/8/2015 17:01'!
spotterAllInstancesFor: aStep
	<spotterOrder: 100>
	aStep listProcessor
		title: 'All instances';
		allCandidates: [ self allInstances ];
		filter: GTFilterSubstring! !

!TClass methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:47'!
spotterClassMethodsFor: aStep
	<spotterOrder: 15>
	aStep listProcessor
			title: 'Class methods';
			allCandidates: [ self classSide methods ];
			itemName: [ :method | method selector ];
			filter: GTFilterSubstring! !

!TClass methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:47'!
spotterMethodsFor: aStep
	<spotterOrder: 10>
	aStep listProcessor
			title: 'Instance methods';
			allCandidates: [ self methods ];
			itemName: [ :method | method selector ];
			filter: GTFilterSubstring! !

!TClass methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/28/2015 21:04'!
spotterPreviewCodeIn: aComposite
	<spotterPreview: 10>
	aComposite pharoMethod
		title: [self name];
		display: #definitionForNautilus;
		smalltalkClass: [ nil ];
		entity: self.
		
	self flag: 'move "entity: self" somewhere else, maybe'! !

!TClass methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:47'!
spotterReferenceFor: aStep
	<spotterOrder: 30>
	aStep listProcessor
			title: 'References';
			allCandidates: [ (SystemNavigation default allReferencesTo: self binding) collect: #compiledMethod ];
			itemName: [ :method | method gtDisplayString ];
			filter: GTFilterSubstring! !

!TClass methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AliakseiSyrel 3/22/2015 15:42'!
spotterSuperClassMethodsFor: aStep
	<spotterOrder: 16>
	|superclasses|
	superclasses := self class withAllSuperclasses select: #isMeta.
	aStep listProcessor
			title: 'Super class methods';
			allCandidates: [ self classSide allMethods select: [ :each |(each methodClass = self classSide) not & (superclasses includes: each methodClass) ] ];
			filter: GTFilterSubstring! !

!TClass methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:47'!
spotterSuperMethodsFor: aStep
	<spotterOrder: 11>
	aStep listProcessor
			title: 'Super instance methods';
			allCandidates: [ self allMethods reject: [ :each | each methodClass = self ] ];
			filter: GTFilterSubstring! !

!MenuItemMorph methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/21/2014 11:13'!
spotterActDefault
	self doButtonAction! !

!MenuItemMorph methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/26/2014 12:21'!
spotterItemsFor: aStep
	<spotterOrder: 10>
	self hasSubMenu ifTrue: [ 
		self subMenu spotterItemsFor: aStep ]! !

!MenuItemMorph methodsFor: '*GT-SpotterExtensions-Core' stamp: 'AliakseiSyrel 1/29/2015 03:21'!
spotterPreviewMenuIn: aComposite
	<spotterPreview: 10>
	
	aComposite list
		title: [ self contents ];
		display: #yourself;
		format: [ :item | 
			GTSpotterItemBrick new 
				text: item contents; 
				icon: item icon; 
				disable;
				yourself ];
		styled: [ :brick | brick ];
		entity: (self hasSubMenu ifFalse: [ {self} ] ifTrue: [ self subMenu allItems ]).
		
	self flag: 'move "entity: self" somewhere else, maybe'! !

!MCRepository methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/17/2015 15:53'!
gtDisplayOn: aStream
	aStream nextPutAll: self description! !

!Slot methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:46'!
spotterAccessesFor: aStep
	<spotterOrder: 10>
	(aStep spotter hasPreviousStep and: [
		(aStep spotter previousStep origin isKindOf: Class) or: [
			aStep origin isKindOf: Class]]) ifTrue: [
		aStep listProcessor
				title: 'Accesses';
				allCandidates: [ 
					SystemNavigation default 
						allAccessesTo: self name 
						from: aStep spotter previousStep origin ];
				itemName: [:each | each asString];
				filter: GTFilterSubstring ]! !

!TBehavior methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:46'!
spotterCompositionFor: aStep
	<spotterOrder: 25>
	aStep listProcessor
			title: 'Composing traits';
			allCandidates: [ self traitComposition allTraits ];
			itemIcon: #systemIcon;
			filter: GTFilterSubstring! !

!TBehavior methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:46'!
spotterSubclassesFor: aStep
	<spotterOrder: 50>
	aStep listProcessor
			title: 'All subclasses';
			allCandidates: [ self allSubclasses ];
			itemIcon: #systemIcon;
			filter: GTFilterSubstring! !

!TBehavior methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:46'!
spotterSuperclassesFor: aStep
	<spotterOrder: 40>
	aStep listProcessor
			title: 'All superclasses';
			allCandidates: [ self allSuperclasses ];
			itemIcon: #systemIcon;
			filter: GTFilterSubstring! !

!TBehavior methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:47'!
spotterTraitUsersFor: aStep
	<spotterOrder: 20>
	aStep listProcessor
			title: 'Users';
			allCandidates: [ self traitUsers asArray ];
			itemIcon: #systemIcon;
			filter: GTFilterSubstring! !

!TBehavior methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/26/2015 21:06'!
spotterUsedSlotsFor: aStep
	<spotterOrder: 70>
	aStep listProcessor
			title: 'Special Slots';
			allCandidates: [ self slots select: [ :slot | slot isSpecial ] ];
			itemName: [ :item | item definitionString ];
			filter: GTFilterSubstring! !

!TBehavior methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:47'!
spotterUsedTraitsFor: aStep
	<spotterOrder: 60>
	aStep listProcessor
			title: 'Uses Traits';
			allCandidates: [ self traits asArray ];
			itemIcon: #systemIcon;
			filter: GTFilterSubstring! !

!RPackageTag methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:46'!
spotterClassesFor: aStep
	<spotterOrder: 20>
	aStep listProcessor
			allCandidates: [ self classes sorted: [ :a :b | a name < b name ] ];
			title: 'Classes';
			filter: GTFilterSubstring! !

!CompiledMethod methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/18/2014 23:22'!
spotterActDefault
	^ self browse! !

!CompiledMethod methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:44'!
spotterForImplementorsFor: aStep
	<spotterOrder: 10>
	aStep listProcessor
			title: 'Implementors';
			allCandidates: [ self implementors collect: #compiledMethod ];
			filter: GTFilterSubstring! !

!CompiledMethod methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 15:16'!
spotterForSendersFor: aStep
	<spotterOrder: 10>
	aStep listProcessor
			title: 'Senders';
			allCandidates: [ self senders collect: #compiledMethod ];
			filter: GTFilterSubstring! !

!CompiledMethod methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/20/2014 23:13'!
spotterItemsFor: aStep
	"do nothing for compiled method"! !

!CompiledMethod methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 3/13/2015 18:19'!
spotterPreviewCodeIn: aComposite
	<spotterPreview: 10>
	aComposite pharoMethod
		title: [ self gtDisplayString ];
		display: [:compiledMethod | 
			' ', compiledMethod getSource];
		smalltalkClass: [self methodClass];
		entity: self.
		
	self flag: 'move "entity: self" somewhere else, maybe'! !

!GlobalVariable methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/14/2015 14:35'!
spotterActDefault
	self value inspect! !

!GlobalVariable methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:44'!
spotterClassFor: aStep
	<spotterOrder: 50>
	aStep listProcessor
			title: 'Class';
			allCandidates: [ { self value class }];
			itemIcon: #systemIcon;
			filter: GTFilterSubstring! !

!GlobalVariable methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:44'!
spotterReferenceFor: aStep
	<spotterOrder: 130>
	aStep listProcessor
			title: 'References';
			allCandidates: [ (SystemNavigation default allReferencesTo: self) collect: #compiledMethod ];
			itemName: [ :method | method gtDisplayString ];
			filter: GTFilterSubstring! !

GTFilterSubstring subclass: #GTFilterFileReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-SpotterExtensions-Core'!

!GTFilterFileReference methodsFor: 'private' stamp: 'StefanReichhart 3/22/2015 15:12'!
indexForItem: each
	^ (self queryForItem: each) isEmpty
		ifTrue: [ 1 ] " if the modified query is empty, take all items -> index = 1 "
		ifFalse: [ super indexForItem: each ]! !

!GTFilterFileReference methodsFor: 'accessing' stamp: 'StefanReichhart 3/22/2015 21:47'!
queryForItem: each
	" hack: see senders of #queryForFileReference "
	^ self context cacheAt: #queryForFileReference ifAbsent: [ self query ]! !

!GTPlayPage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/18/2014 23:00'!
spotterActDefault
	^ GTPlayground new openOn: self! !

!GTPlayPage methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/28/2015 21:02'!
spotterPreviewCodeIn: aComposite
	<spotterPreview: 10>
	aComposite pharoMethod
		title: 'Preview';
		display: #content;
		smalltalkClass: [ nil ];
		entity: self.
		
	self flag: 'move "entity: self" somewhere else, maybe'! !

!MenuMorph methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 11/22/2014 17:33'!
allItems
	| all |
	all := OrderedCollection new.
	self items do: [ :each |
		all add: each.
		each hasSubMenu 
			ifTrue: [ all addAll: each subMenu allItems ] ].
	^ all! !

!MenuMorph methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:45'!
spotterItemsFor: aStep
	<spotterOrder: 10>
	^ aStep listProcessor 
		title: 'Items';
		candidatesLimit: Float infinity;
		allCandidates: [ self items ];
		itemName: #contents;
		itemIcon: [ :item | item icon ];
		actLogic: [ :item | item hasSubMenu 
					ifTrue: [ aStep diveIn ] 
					ifFalse: [ item spotterActDefault. aStep exit ] ];
		filter: GTFilterSubstring ! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 2/2/2015 14:34'!
isZipFile
	^ self isFile and: [ #('zip' 'jar' 'ear' 'war') includes: self extension ]! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:44'!
spotterForDirectoriesFor: aStep
	<spotterOrder: 10>
	^ self isDirectory ifTrue: [
		aStep listProcessor
			allCandidates: [ self directories ];
			title: 'Directories';
			candidatesLimit: Float infinity;
			itemName: #basename;
			itemIcon: [ GLMUIThemeExtraIcons glamorousFolder ];
			filter: GTFilterSubstring ]! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:44'!
spotterForFilesFor: aStep
	<spotterOrder: 20>
	^ self isDirectory ifTrue: [
		aStep listProcessor
			allCandidates: [ self files ];
			title: 'Files';
			candidatesLimit: Float infinity;
			itemName: #basename;
			itemIcon: [ GLMUIThemeExtraIcons glamorousBrowse ];
			filter: GTFilterSubstring ]! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 3/2/2015 22:26'!
spotterForZipDirectoriesFor: aStep
	<spotterOrder: 10>
	| zipFileSystem |
	self isZipFile ifFalse: [ ^ self ].
	aStep listProcessor
			allCandidates: [ 
				zipFileSystem := (FileSystem zip: self) open.
				zipFileSystem workingDirectory directories ];
			title: 'Directories';
			candidatesLimit: Float infinity;
			itemName: #basename;
			itemIcon: [ GLMUIThemeExtraIcons glamorousFolder ];
			filter: GTFilterSubstring! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/24/2015 14:44'!
spotterForZipFilesFor: aStep
	<spotterOrder: 10>
	| zipFileSystem |
	self isZipFile ifFalse: [ ^ self ].
	aStep listProcessor
			allCandidates: [ 
				zipFileSystem := (FileSystem zip: self) open.
				zipFileSystem workingDirectory files ];
			title: 'Files';
			candidatesLimit: Float infinity;
			itemName: #basename;
			itemIcon: [ GLMUIThemeExtraIcons glamorousBrowse ];
			filter: GTFilterSubstring
	! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 3/9/2015 08:11'!
spotterPreviewContentsIn: aComposite
	<spotterPreview: 20>
	
	self isFile ifFalse: [ ^ self ].
	aComposite text
		title: [ self gtDisplayString ]; 
		display: #yourself;
		entity: (self readStreamDo: [ :stream | 
					| result |
					result := [(stream next: 10000) asString]
						on: Error 
						do: [ (stream binary next: 10000) asString ].
					stream size > 10000
						ifTrue: [ result, '  ... truncated ...' ]
						ifFalse: [ result ] ])! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/28/2015 21:00'!
spotterPreviewItemsIn: aComposite
	<spotterPreview: 10>
	
	self isDirectory ifFalse: [ ^ self ].
	aComposite list
		title: [ self gtDisplayString ];
		display: #yourself;
		format: [ :folder | 
			GTSpotterItemBrick new 
				text: folder basename; 
				icon: (folder isDirectory 
								ifTrue: [Smalltalk ui theme icons glamorousFolder]
								ifFalse: [Smalltalk ui theme icons glamorousBrowse] ); 
				disable; 
				yourself ];
		styled: [ :brick | brick ];
		entity: self directories, self files.
		
	self flag: 'move "entity: self" somewhere else, maybe'! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 1/28/2015 21:57'!
spotterPreviewPngIn: aComposite
	<spotterPreview: 10>
	
	(self mimeTypes notNil and: [ 
		self mimeTypes first matches: ZnMimeType imagePng ]) 
		ifFalse: [ ^ self ].
	aComposite custom: 
		((self binaryReadStreamDo: [ :stream | PNGReadWriter formFromStream: stream ])
			asAlphaImageMorph asBrick margin: 20)! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 3/9/2015 08:08'!
spotterPreviewStScriptIn: aComposite
	<spotterPreview: 10>
	
	(self extension = 'st' or: [self extension = 'ph']) 
		ifFalse: [ ^ self ].
	aComposite pharoMethod 
		title: [self gtDisplayString];
		display: #yourself;
		smalltalkClass: [ nil ];
		entity: (self readStreamDo: #contents)! !

!FileReference methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 3/11/2015 22:05'!
spotterPreviewZipItemsIn: aComposite
	<spotterPreview: 10>

	| zip |
	self isZipFile ifFalse: [ ^ self ].
	zip:= (FileSystem zip: self) open workingDirectory.
	aComposite list
		title: [ self gtDisplayString ];
		display: #yourself;
		format: [ :folder | 
			GTSpotterItemBrick new 
				text: folder basename; 
				icon: (folder isDirectory 
								ifTrue: [Smalltalk ui theme icons glamorousFolder]
								ifFalse: [Smalltalk ui theme icons glamorousBrowse] ); 
				disable; 
				yourself ];
		styled: [ :brick | brick ];
		entity: (zip directories, zip files)! !

!MetacelloVersion methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/26/2015 21:00'!
spotterForGroupsFor: aStep
	<spotterOrder: 2>
	aStep listProcessor
		title: 'Groups';
		allCandidates: [ self groups ];
		itemName: [ :item | item name ];
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!MetacelloVersion methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/26/2015 21:00'!
spotterForPackagesFor: aStep
	<spotterOrder: 3>
	aStep listProcessor
		title: 'Packages';
		allCandidates: [ self packages ];
		itemName: [ :item | item file ];
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!AbstractNautilusUI methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/18/2015 09:55'!
runTestsOfSuite: aSuite notifying: aBoolean
	<demoOnly: 'this is very ugly code, a copy from the original implementation, adapted to aSuite'>
	|  blockToEvaluate result |

	blockToEvaluate := [
		[ 
		| classes |
		classes := (aSuite tests collect: [ :each | each class ]) asSet.
		classes do: [ :class | class resetHistory ].
		result := aSuite run.
		result updateResultsInHistory.
		classes do: [ :class | ClassesIconsCache removeKey: class ifAbsent: []. ].
		testSemaphore signal. ] on: Exception do:[:e | testSemaphore signal . e defaultAction]].

	aBoolean 
		ifTrue: [ blockToEvaluate forkAt: Processor userBackgroundPriority ]
		ifFalse: [ blockToEvaluate value ].

	testSemaphore
		initSignals;
		wait.
	
	aBoolean 
		ifTrue: [ 
			| color |
			color := Color gray.
			result hasPassed ifTrue: [ color :=  Color green ].
			result hasFailures ifTrue: [ color :=  Color yellow ].
			result hasErrors ifTrue: [ color :=  Color red ].
			
			self 
				notifyTitle: 'Test Finished' 
				contents: 'Class: ', aSuite name
				color: color ]! !

!MCDirectoryRepository methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/17/2015 15:51'!
gtDisplayOn: aStream
	aStream nextPutAll: self description! !

!MetacelloAbstractPackageSpec methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/26/2015 21:00'!
spotterForIncludesFor: aStep
	<spotterOrder: 1>
	aStep listProcessor
		title: 'Includes';
		allCandidates: [ self includes ];
		itemName: [ :item | item name ];
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!MetacelloAbstractPackageSpec methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/26/2015 21:00'!
spotterForRequiresFor: aStep
	<spotterOrder: 2>
	aStep listProcessor
		title: 'Requires';
		allCandidates: [ self requires ];
		itemName: [ :item | item name ];
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!MetacelloProject methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 2/26/2015 20:59'!
spotterForVersionsFor: aStep
	<spotterOrder: 1>
	aStep listProcessor
		title: 'Versions';
		allCandidates: [
			(#( stableVersion currentVersion bleedingEdge development ) 
				collect: [ :each | [ self perform: each ] on: Error do: [  nil ] ]) 
				reject: [ :each | each isNil ] ];
		itemName: [ :version | version versionString ];
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!Object methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 2/21/2015 21:56'!
gtInspectorActionSpot
	<gtInspectorAction>
	^ GLMGenericAction new
		action: [ 
			GTSpotterMorph new
				extent: 400@500;
				doLayout;
				spotterModel: (GTSpotter on: self);
				openCenteredInWorld
			 ];
		icon: GLMUIThemeExtraIcons glamorousSearch;
		condition: [ 
				| fakeStep |
				fakeStep := GTSpotter new newStep origin: self.
				self spotterProcessorsFor: fakeStep.
				fakeStep processors notEmpty ];
		title: 'Search'! !

Object subclass: #PragmaType
	instanceVariableNames: 'keyword pragmas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-SpotterExtensions-Core'!

!PragmaType commentStamp: 'TudorGirba 11/16/2014 12:57' prior: 0!
This models the type of pragma instances.

It essentially knows the keyword that defines the Pragma, and can obtain all occurences of that Pragma.

!!!!Example

[[[
	PragmaType all
]]]!

!PragmaType class methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2014 12:52'!
all
	| pragmas |
	pragmas := OrderedCollection new.
	Object withAllSubclassesDo: [:each |
		Pragma withPragmasIn: each do: [:p |
			pragmas add: p]].
	^ (pragmas groupedBy: #keyword) associations collect: [ :association |
		PragmaType new
			keyword: association key; 
			pragmas: association value ] ! !

!PragmaType class methodsFor: 'examples' stamp: 'TudorGirba 3/21/2015 22:57'!
exampleAnyOne
	<example>
	^ self all anyOne! !

!PragmaType methodsFor: 'ui' stamp: 'TudorGirba 11/16/2014 12:54'!
gtInspectorPragmasIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Pragmas';
		display: [ self pragmas ];
		format: #gtDisplayString! !

!PragmaType methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2014 10:07'!
keyword
	^ keyword! !

!PragmaType methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2014 10:07'!
keyword: anObject
	keyword := anObject! !

!PragmaType methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2014 12:58'!
pragmas
	^ pragmas ifNil: [
		pragmas := OrderedCollection new.
		Object withAllSubclassesDo: [ :each |
			Pragma withPragmasIn: each do: [ :p |
				p keyword = self keyword ifTrue: [ 
					pragmas add: p ] ] ].
		pragmas ]! !

!PragmaType methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2014 12:52'!
pragmas: aCollection
	pragmas := aCollection! !

!PragmaType methodsFor: 'ui' stamp: 'TudorGirba 11/16/2014 12:53'!
printOn: stream
	stream nextPutAll: self keyword! !

!PragmaType methodsFor: 'ui' stamp: 'StefanReichhart 2/24/2015 14:46'!
spotterPragmasFor: aStep
	<spotterOrder: 40>
	^ aStep listProcessor
		title: 'Pragmas';
		allCandidates: [ self pragmas ];
		itemName: [ :pragma | pragma method printString , ' ' , pragma asString ];
		filter: GTFilterSubstring! !

!PragmaType methodsFor: 'as yet unclassified' stamp: 'StefanReichhart 3/22/2015 21:51'!
spotterSendersFor: aStep
	<spotterOrder: 50>
	^ aStep listProcessor
		title: 'Senders';
		allCandidates: [ (SystemNavigation default allSendersOf: self keyword) collect: #compiledMethod ];
		filter: GTFilterSubstring! !

!Collection methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/22/2015 21:29'!
spotterItemsFor: aStep
	<spotterOrder: 10>
	| processor |
	self ifEmpty: [ ^ self ].
	processor := aStep previousProcessorFrom: self.
	^ aStep listProcessor
		title: processor title;
		candidatesLimit: 100;
		items: [ OrderedCollection newFrom: (self collect: [ :each | each asSpotterCandidateLink value]) ];
		itemName: processor itemName;
		itemFilterName: processor itemFilterName;
		filter: processor filter gtListFilter;
		wantsToDisplayOnEmptyQuery: true! !

!Collection methodsFor: '*GT-SpotterExtensions-Core' stamp: 'StefanReichhart 3/22/2015 23:41'!
spotterSelectFor: aStep
	<spotterOrder: 40>
	self flag: #specialFilter.
	aStep listProcessor
		title: 'Expression selection';
		filter: GTNullFilter item: [ :filter :context |
			self do: [ :each |
				[ (Smalltalk compiler 
						evaluate: '| each | each := self. ', context text 
						for: each asSpotterCandidateLink value
						logged: false) ifTrue: [ filter value: each ]  ] on: Error do: [ " ignore this item, continue with the next one " ] ] ]! !

!Pragma methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 12/15/2014 00:01'!
spotterActDefault
    ^ self method browse! !

!Pragma methodsFor: '*GT-SpotterExtensions-Core' stamp: 'TudorGirba 3/13/2015 18:19'!
spotterPreviewIn: composite
	<spotterPreview: 10>
   self method spotterPreviewCodeIn: composite! !
